Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/JDBCServerExplorerBase.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/JDBCServerExplorerBase.java	(revision 43376)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/JDBCServerExplorerBase.java	(revision 43377)
@@ -22,6 +22,7 @@
  */
 package org.gvsig.fmap.dal.store.jdbc2.spi;
 
+import java.io.File;
 import org.gvsig.fmap.dal.store.jdbc2.JDBCServerExplorer;
 import java.util.ArrayList;
 import java.util.Arrays;
@@ -46,6 +47,7 @@
 import org.gvsig.fmap.dal.SQLBuilder.Privilege;
 import org.gvsig.fmap.dal.resource.spi.ResourceProvider;
 import org.gvsig.fmap.dal.serverexplorer.db.spi.AbstractDBServerExplorer;
+import org.gvsig.fmap.dal.serverexplorer.filesystem.FilesystemStoreParameters;
 import org.gvsig.fmap.dal.spi.DataManagerProviderServices;
 import org.gvsig.fmap.dal.spi.DataServerExplorerProviderServices;
 import org.gvsig.fmap.dal.store.jdbc.JDBCConnectionParameters;
@@ -60,6 +62,7 @@
 import org.gvsig.fmap.dal.store.jdbc2.spi.operations.FetchFeatureTypeOperation;
 import org.gvsig.fmap.dal.store.jdbc2.spi.operations.ListTablesOperation;
 import org.gvsig.fmap.dal.store.jdbc2.spi.operations.DropTableOperation;
+import org.gvsig.fmap.dal.store.jdbc2.spi.operations.ExecuteOperation;
 import org.gvsig.fmap.dal.store.jdbc2.spi.operations.UpdateTableStatisticsOperation;
 import org.gvsig.tools.exception.BaseException;
 import org.slf4j.Logger;
@@ -166,6 +169,10 @@
         params.setSchema(parameters.getSchema());
         params.setJDBCDriverClassName(parameters.getJDBCDriverClassName());
         params.setUrl(parameters.getUrl());
+        if( parameters instanceof FilesystemStoreParameters ) {
+            File f = ((FilesystemStoreParameters) parameters).getFile();
+            ((FilesystemStoreParameters) params).setFile(f);
+        }
         return params;
     }
 
@@ -182,6 +189,10 @@
         params.setSchema(parameters.getSchema());
         params.setJDBCDriverClassName(parameters.getJDBCDriverClassName());
         params.setUrl(parameters.getUrl());
+        if( parameters instanceof FilesystemStoreParameters ) {
+            File f = ((FilesystemStoreParameters) parameters).getFile();
+            ((FilesystemStoreParameters) params).setFile(f);
+        }
 
         params.setDefaultFeatureType(this.getServerExplorerProviderServices()
                 .createNewFeatureType());
@@ -362,6 +373,12 @@
     }
 
     @Override
+    public void execute(String sql) {
+        ExecuteOperation execute = this.getOperations().createExecute(sql);
+        execute.perform();
+    }
+
+    @Override
     public DataStoreParameters get(String name) throws DataException {
         JDBCStoreParameters params = this.getOpenParameters();
         params.setTable(name);
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/JDBCHelperBase.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/JDBCHelperBase.java	(revision 43376)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/JDBCHelperBase.java	(revision 43377)
@@ -4,6 +4,9 @@
 import org.gvsig.fmap.dal.store.jdbc2.spi.operations.OperationsFactoryBase;
 import java.sql.Connection;
 import java.sql.ResultSet;
+import java.sql.SQLException;
+import org.apache.commons.dbcp.BasicDataSource;
+import org.apache.commons.lang3.BooleanUtils;
 import org.apache.commons.lang3.StringUtils;
 import org.cresques.cts.IProjection;
 import org.gvsig.fmap.crs.CRSFactory;
@@ -31,6 +34,7 @@
 import org.gvsig.fmap.dal.store.jdbc.JDBCServerExplorerParameters;
 import org.gvsig.fmap.dal.store.jdbc.JDBCStoreParameters;
 import org.gvsig.fmap.dal.store.jdbc.exception.JDBCCantFetchValueException;
+import org.gvsig.fmap.dal.store.jdbc.exception.JDBCDriverClassNotFoundException;
 import org.gvsig.fmap.dal.store.jdbc2.JDBCHelper;
 import org.gvsig.fmap.dal.store.jdbc2.JDBCServerExplorer;
 import org.gvsig.fmap.dal.store.jdbc2.JDBCStoreProvider;
@@ -43,6 +47,7 @@
 import org.gvsig.fmap.geom.GeometryManager;
 import org.gvsig.tools.dispose.impl.AbstractDisposable;
 import org.gvsig.tools.exception.BaseException;
+import org.gvsig.tools.exception.NotYetImplemented;
 import org.slf4j.Logger;
 import org.slf4j.LoggerFactory;
 
@@ -53,8 +58,6 @@
     private static final String QUOTE_FOR_USE_IN_STRINGS = "'";
 
     private static final Logger logger = LoggerFactory.getLogger(JDBCHelperBase.class);
-    
-//    protected JDBCResource resource = null;
 
     private ResulSetControler resulSetControler = null;
 
@@ -193,11 +196,15 @@
 
     @Override
     public Connection getConnection() throws AccessResourceException {
-//        return this.resource.getJDBCConnection();
-        return null;
+        throw new NotYetImplemented();
     }
 
     @Override
+    public Connection getConnectionWritable() throws AccessResourceException {
+        return this.getConnection();
+    }
+
+    @Override
     public String getConnectionURL() {
         return null;
     }
@@ -209,9 +216,15 @@
 
     @Override
     public void closeConnection(Connection connection) {
-//        this.getResource().closeConnection(connection);
-        JDBCUtils.closeQuietly(connection);
+        if( connection != null ) {
+            logger.debug("Clossing connection "+connection.hashCode());
+            try {
+                connection.close();
+            } catch(Exception ex) {
+                logger.warn("Can't close connection.", ex);
+            }
        }
+    }
     
     @Override
     protected void doDispose() throws BaseException {
@@ -341,12 +354,14 @@
 
     @Override
     public String getDatabaseCodeFromProyection(IProjection proj) {
-        String[] s = proj.getAbrev().split(":");
         return this.srss.getDatabaseCode(proj.getAbrev());
     }
     
     @Override
     public IProjection getProjectionFromDatabaseCode(String databaseCode) {
+        if( StringUtils.trimToEmpty(databaseCode).equals("0") ) {
+            return null;
+        }
         String abbrev = this.srss.getApplicationAbbrev(databaseCode);
         if( StringUtils.isEmpty(abbrev) ) {
             return null;
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/CreateTableOperation.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/CreateTableOperation.java	(revision 43376)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/CreateTableOperation.java	(revision 43377)
@@ -15,7 +15,7 @@
 import org.gvsig.fmap.dal.store.jdbc2.JDBCUtils;
 import org.gvsig.fmap.geom.DataTypes;
 
-public class CreateTableOperation extends AbstractConnectionOperation {
+public class CreateTableOperation extends AbstractConnectionWritableOperation {
 
     private final String schemaName;
     private final String tableName;
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/DropTableOperation.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/DropTableOperation.java	(revision 43376)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/DropTableOperation.java	(revision 43377)
@@ -9,7 +9,7 @@
 import org.gvsig.fmap.dal.store.jdbc.exception.JDBCSQLException;
 import org.gvsig.fmap.dal.store.jdbc2.JDBCUtils;
 
-public class DropTableOperation extends AbstractConnectionOperation {
+public class DropTableOperation extends AbstractConnectionWritableOperation {
 
     private final String schemaName;
     private final String tableName;
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/AbstractConnectionWritableOperation.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/AbstractConnectionWritableOperation.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/AbstractConnectionWritableOperation.java	(revision 43377)
@@ -0,0 +1,23 @@
+
+package org.gvsig.fmap.dal.store.jdbc2.spi.operations;
+
+import java.sql.Connection;
+import org.gvsig.fmap.dal.resource.exception.AccessResourceException;
+import org.gvsig.fmap.dal.store.jdbc2.JDBCHelper;
+
+
+public abstract class AbstractConnectionWritableOperation extends AbstractConnectionOperation {
+
+    public AbstractConnectionWritableOperation(JDBCHelper helper) {
+        super(helper);
+    }
+    
+    @Override
+    protected Connection getConnection() throws AccessResourceException {
+        if( this.conn == null ) {
+            this.conn = this.helper.getConnectionWritable();
+        }
+        return this.conn;  
+    }
+    
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/AbstractConnectionOperation.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/AbstractConnectionOperation.java	(revision 43376)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/AbstractConnectionOperation.java	(revision 43377)
@@ -2,10 +2,7 @@
 
 import java.sql.Connection;
 import java.sql.SQLException;
-import java.util.logging.Level;
-import org.gvsig.fmap.dal.exception.DataException;
-import org.gvsig.fmap.dal.resource.ResourceAction;
-import org.gvsig.fmap.dal.resource.spi.ResourceProvider;
+import org.gvsig.fmap.dal.resource.exception.AccessResourceException;
 import org.gvsig.fmap.dal.store.jdbc.exception.JDBCTransactionRollbackException;
 import org.gvsig.fmap.dal.store.jdbc2.JDBCHelper;
 import org.gvsig.fmap.dal.store.jdbc2.spi.JDBCSQLBuilderBase;
@@ -18,7 +15,7 @@
 
     final protected JDBCHelper helper;
     
-    private Connection conn = null;
+    protected Connection conn = null;
 
     public AbstractConnectionOperation(JDBCHelper helper) {
         this.helper = helper;
@@ -49,52 +46,52 @@
         }
     }
 
-    protected Connection getConnection() {
+    protected Connection getConnection() throws AccessResourceException {
+        if( this.conn == null ) {
+            this.conn = this.helper.getConnection();
+        }
         return this.conn;
     }
     
-    public Object perform_operation() throws Exception {
-            Object result = null;
-        try {
-            logger.debug("preparing execution of "+this.getClass().getSimpleName()+".");
-            conn = helper.getConnection();
-
-            // XXX OJO esta condicion NO ES FIABLE
-            if (!conn.getAutoCommit()) {
-                if (!continueTransactionAllowed()) {
-                    throw new SQLException("nested operations not allowed.");
+    protected Object perform_operation() throws Exception {
+        Object result = null;
+        logger.debug("preparing execution of "+this.getClass().getSimpleName()+".");
+        if( needTransaction() ) {
+            try {
+                // XXX OJO esta condicion NO ES FIABLE
+                if (!this.getConnection().getAutoCommit()) {
+                    if (!continueTransactionAllowed()) {
+                        throw new SQLException("nested operations not allowed.");
+                    }
                 }
+                this.getConnection().setAutoCommit(false);
+                try {
+                    logger.debug("Excuting operation {}.", this.getClass().getSimpleName());
+                    result = perform(this.getConnection());
+                } catch (Exception ex) {
+                    try {
+                        this.getConnection().rollback();
+                    } catch (Exception e1) {
+                        throw new JDBCTransactionRollbackException(e1, ex);
+                    }
+                    throw new RuntimeException("Can't perform operation '"+this.getClass().getSimpleName()+"'.",ex);
+                }
+                this.getConnection().commit();
+            } finally {
+                helper.closeConnection(this.getConnection());
+                conn = null;
             }
-            conn.setAutoCommit(false);
+        } else {
             try {
                 logger.debug("Excuting operation {}.", this.getClass().getSimpleName());
-                result = perform(conn);
+                result = perform(this.getConnection());
             } catch (Exception ex) {
-                try {
-                    conn.rollback();
-                } catch (Exception e1) {
-                    throw new JDBCTransactionRollbackException(e1, ex);
-                }
                 throw new RuntimeException("Can't perform operation '"+this.getClass().getSimpleName()+"'.",ex);
+            } finally {
+                helper.closeConnection(this.getConnection());
+                conn = null;
             }
-            conn.commit();
-            return result;
-        } finally {
-            helper.closeConnection(conn);
-            conn = null;
         }
+        return result;
     }
-//
-//    public Object perform2() {
-//        ResourceProvider resource = this.helper.getResource();
-//        Object r = resource.execute(new ResourceAction() {
-//
-//            @Override
-//            public Object run() throws Exception {
-//                return perform_operation();
-//            }
-//        });
-//        return r;
-//    }
-
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/OperationsFactoryBase.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/OperationsFactoryBase.java	(revision 43376)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/OperationsFactoryBase.java	(revision 43377)
@@ -36,6 +36,15 @@
         return new FetchFeatureTypeOperation(helper, type, database, schema, table, 
                 primaryKeys, defaultGeometryField, crs);
     }
+    
+//    @Override
+//    public FetchFeatureTypeOperation createFetchFeatureType(
+//            EditableFeatureType type, 
+//            String defaultGeometryField, 
+//            IProjection crs
+//        ) {
+//        return new FetchFeatureTypeOperation(helper, type, defaultGeometryField, crs);
+//    }
 
     @Override
     public FetchFeatureProviderByReferenceOperation createFetchFeatureProviderByReference(
@@ -192,4 +201,9 @@
         return new CanModifyTableOperation(helper, dbName, schemaName, tableName);
     }
     
+    @Override
+    public ExecuteOperation createExecute(String sql) {
+        return new ExecuteOperation(helper, sql);
+    }
+    
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/ResultSetForSetProviderOperation.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/ResultSetForSetProviderOperation.java	(revision 43376)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/ResultSetForSetProviderOperation.java	(revision 43377)
@@ -63,14 +63,19 @@
     }
 
     @Override
-    public final Object perform(Connection conn) throws DataException {
+    protected Object perform_operation() throws Exception {
         ResultSetEntry rs = createResultSet(
                 database, schema, table, subquery, 
                 baseFilter, baseOrder, storeType, setType, query, 
                 limit, offset, fetchSize);
         return rs;
     }
-
+    
+    @Override
+    public Object perform(Connection conn) throws DataException {
+        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
+    }
+    
     public ResultSetEntry createResultSet(
             String database,
             String schema,
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/ExecuteOperation.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/ExecuteOperation.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/ExecuteOperation.java	(revision 43377)
@@ -0,0 +1,44 @@
+package org.gvsig.fmap.dal.store.jdbc2.spi.operations;
+
+import java.sql.Connection;
+import java.sql.SQLException;
+import java.sql.Statement;
+import org.gvsig.fmap.dal.exception.DataException;
+import org.gvsig.fmap.dal.store.jdbc2.JDBCHelper;
+import org.gvsig.fmap.dal.store.jdbc2.JDBCUtils;
+
+public class ExecuteOperation extends AbstractConnectionOperation {
+
+    private final String sql;
+    
+    public ExecuteOperation(
+            JDBCHelper helper,
+            String sql
+        ) {
+        super(helper);
+        this.sql = sql;
+    }
+
+    @Override
+    public final Object perform(Connection conn) throws DataException {
+        this.execute(conn, sql);
+        return null;
+    }
+
+    public void execute(
+            Connection conn,
+            String sql
+    ) {
+        Statement st = null;
+        try {
+            st = conn.createStatement();
+            JDBCUtils.execute(st, sql);
+        } catch (SQLException ex) {
+            throw new RuntimeException("Can't execute query ["+sql+"].",ex);
+            
+        } finally {
+            JDBCUtils.closeQuietly(st);
+        }
+
+    }
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/PerformChangesOperation.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/PerformChangesOperation.java	(revision 43376)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/PerformChangesOperation.java	(revision 43377)
@@ -13,6 +13,7 @@
 import org.gvsig.fmap.dal.feature.spi.FeatureReferenceProviderServices;
 import org.gvsig.fmap.dal.feature.spi.FeatureStoreProvider;
 import org.gvsig.fmap.dal.feature.spi.SQLBuilderBase;
+import org.gvsig.fmap.dal.resource.exception.AccessResourceException;
 import org.gvsig.fmap.dal.store.jdbc2.JDBCHelper;
 import org.gvsig.fmap.dal.store.jdbc.exception.JDBCExecuteSQLException;
 import org.gvsig.fmap.dal.store.jdbc.exception.JDBCSQLException;
@@ -20,7 +21,7 @@
 import org.gvsig.fmap.dal.store.jdbc2.spi.JDBCSQLBuilderBase;
 import org.gvsig.fmap.dal.store.jdbc2.JDBCUtils;
 
-public class PerformChangesOperation extends AbstractConnectionOperation {
+public class PerformChangesOperation extends AbstractConnectionWritableOperation {
 
     protected String dbName;
     protected String schemaName;
@@ -60,7 +61,7 @@
     public boolean isTypeChanged() {
         return typeChanged;
     }
-    
+
     @Override
     public final Object perform(Connection conn) throws DataException {
         if (featureTypesChanged.hasNext()) {
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/UpdateTableStatisticsOperation.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/UpdateTableStatisticsOperation.java	(revision 43376)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/UpdateTableStatisticsOperation.java	(revision 43377)
@@ -10,7 +10,7 @@
 import org.gvsig.fmap.dal.store.jdbc.exception.JDBCSQLException;
 import org.gvsig.fmap.dal.store.jdbc2.JDBCUtils;
 
-public class UpdateTableStatisticsOperation extends AbstractConnectionOperation {
+public class UpdateTableStatisticsOperation extends AbstractConnectionWritableOperation {
 
     private final String schemaName;
     private final String tableName;
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/AppendOperation.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/AppendOperation.java	(revision 43376)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/AppendOperation.java	(revision 43377)
@@ -4,6 +4,8 @@
 import java.sql.Connection;
 import java.sql.PreparedStatement;
 import java.sql.SQLException;
+import java.util.logging.Level;
+import java.util.logging.Logger;
 import org.gvsig.fmap.dal.DataTypes;
 import org.gvsig.fmap.dal.exception.DataException;
 import org.gvsig.fmap.dal.feature.FeatureAttributeDescriptor;
@@ -51,7 +53,7 @@
         }
 
         try {
-            this.connection = this.helper.getConnection();
+            this.connection = this.helper.getConnectionWritable();
             
             this.sqlbuilder = this.helper.createSQLBuilder();
 
@@ -76,6 +78,7 @@
             PreparedStatement st;
             this.sql = this.sqlbuilder.insert().toString();
             this.preparedStatement = this.connection.prepareStatement(sql);
+            this.connection.setAutoCommit(false);
             
         } catch (SQLException ex) {
             throw new JDBCPreparingSQLException(this.sqlbuilder.toString(),ex);
@@ -83,44 +86,47 @@
 
     }
     
-    public void end() {
-        JDBCUtils.closeQuietly(this.connection);
+    protected void clean() {
         JDBCUtils.closeQuietly(this.preparedStatement);
+        this.helper.closeConnection(this.connection);
         this.connection = null;
         this.preparedStatement = null;
         this.sqlbuilder = null;
-        this.sql = null;
+        this.sql = null;        
     }
     
-    public void abort() {
-        this.end();
+    public void end() {
+        try {
+            this.connection.commit();
+        } catch (SQLException ex) {
+            try {
+                this.connection.rollback();
+            } catch (SQLException ex1) {
+            }
+            throw new RuntimeException("Can't commit transaction", ex);
+        } finally {
+            clean();
+        }
     }
     
+    public void abort() {        
+        try {
+            this.connection.rollback();
+        } catch (SQLException ex) {
+        }
+        clean();
+    }
+    
     public void append(FeatureProvider feature) throws DataException {
+        int n;
         try {
-            this.connection.setAutoCommit(false);
-            try {
-                this.sqlbuilder.setParameters(this.preparedStatement, feature);
-                int n = JDBCUtils.executeUpdate(this.preparedStatement,this.sql);
-                if ( n > 0) {
-                    this.connection.commit();
-                    return;
-                }              
-                this.connection.rollback();
-            } catch(Exception ex) {
-                try {
-                    this.connection.rollback();
-                } catch (Exception e1) {
-                    throw new JDBCTransactionRollbackException(e1, ex);
-                }                
-                throw new JDBCExecuteSQLException(this.sql,ex);
-            } 
-            throw new JDBCExecuteSQLException(this.sql,null);
-
-        } catch (JDBCExecuteSQLException ex) {
-            throw ex;
-        } catch (Exception ex) {
-            throw new JDBCExecuteSQLException(this.sql,ex);
+            this.sqlbuilder.setParameters(this.preparedStatement, feature);
+            n = JDBCUtils.executeUpdate(this.preparedStatement,this.sql);
+        } catch(Exception ex) {
+            throw new RuntimeException("Can't insert feature.", ex);
         }
+        if( n<1 ) {
+            throw new RuntimeException("Can't insert feature (n="+n+").");
+        }
     }
 }
